/* How to set graphics mode, palette and put a pixel with SvgaLib.

Distribution under GNU-GPL.
Autor : Leandro Bernsmuller 
e-mail: lebe@geocities.com
site  : http://www.geocities.com/SiliconValley/Bay/1704

To compile just type make.

usualy headers are /usr/include/vga*.h
*/



#include <string.h>     // memset
#include <stdlib.h>     // random
#include <stdio.h>      // getchar
#include <vga.h>        // vga lib functions



int main ()
{
   // init SvgaLib
   vga_init ();
  
   printf ( "\nGraphics under Linux console with SvgaLib.\n\n" );
   printf ( "Demo 1 - how to set graphic mode, palette and draw on a frame buffer." );    
   printf ( "\n\nPress ENTER..." );    
   getchar ();
   
   // set graphics mode and palette
   vga_setmode ( G320x200x256 );
   vga_setpalette ( 0, 0, 0, 30 );
   vga_setpalette ( 1, 50, 50, 50 );
 
   // where to draw
   unsigned char
     auchFrameBuffer [ 64000 ];
   
   // clear it
   memset ( (void*) auchFrameBuffer, 0, 64000 );
 
   // draw 150 pixels in frame buffer
   for ( int ncP = 0; ncP < 150; ncP ++ ) {
      int
         nX = random () % 320,  // between 0..319
         nY = random () % 200;  // between 0..199
      memset ( (void*) ( auchFrameBuffer + 320 * nY + nX ), 1, 1 );
   }
 
   // show frame buffer
   // draw scanline per scanline on screen
   for ( int ncL = 0; ncL < 200; ncL ++ )
      vga_drawscansegment ( auchFrameBuffer + ncL * 320, 0, ncL, 320 );
  
   getchar ();
   vga_setmode ( TEXT );
}

