/* How to set graphics mode, palette and use keyboard with SvgaLib.

Distribution under GNU-GPL.
Autor : Leandro Bernsmuller 
e-mail: lebe@geocities.com
site  : http://www.geocities.com/SiliconValley/Bay/1704

To compile just type make.

usualy headers are /usr/include/vga*.h
*/



#include <string.h>     // memset
#include <stdio.h>      // getchar
#include <vga.h>        // vga lib functions



int main ()
{
   // init SvgaLib
   vga_init ();
  
   printf ( "\nGraphics under Linux console with SvgaLib." );
   printf ( "\n\nDemo 2 - using keyboard on a interactive loop in graphic mode." );
   printf ( "\n\nTry press cursor arrow keys (UP, DOWN, RIGHT, LEFT) to move point.\nESC exit." );
   printf ( "\n\nPress ENTER..." );    
   getchar ();
 
   // set graphics mode and palette
   vga_setmode ( G320x200x256 );
   vga_setpalette ( 0, 0, 0, 30 );
   vga_setpalette ( 1, 50, 50, 50 );
   
   // where to draw
   unsigned char
      auchFrameBuffer [ 64000 ];
   
   // clear it
   memset ( (void*) auchFrameBuffer, 0, 64000 );

   int
      nKey,       // key pressed
      nX = 160,   // pixel coordenated
      nY = 100;
   // loop
   for ( ; ; ) {
 
      nKey = vga_getkey ();  // no stop here - drawback: still has keyboard delays
 
      // show the pressed key (on text console)
      if ( nKey != 0 )
         printf ( "key: %d -> '%c'\n", nKey, nKey );
 
      // if key has code 27 then key can be special (on text console)
      if ( nKey == 27 )
 
         // if next is not 91 then had been pressed ESC  
         if ( vga_getkey () != 91 )  // 27 + !=91  ==== ESC, if ==91 -> special
 
            // ESC
            exit ( 0 );
 
        else {
 
           // special key
           printf ("special\n " );
 
           // set pixel position
           switch ( vga_getkey () ) {
 
              case 'A':      // key UP
                 nY = ( nY <= 0 ) ? nY : nY - 1;
                 break;
 
              case 'B':      // key DOWN
                 nY = ( nY >= 199 ) ? nY : nY + 1;
                 break;
 
              case 'C':      // key RIGHT
                 nX = ( nX >= 319 ) ? nX : nX + 1;
                 break;
 
              case 'D':      // key LEFT
                 nX = ( nX <= 0 ) ? nX : nX - 1;
                 break;
           }
      }

      // set a pixel on frame buffer
      memset ( (void*) ( auchFrameBuffer + 320 * nY + nX ), 1, 1 );
     
      // wait vertical retrace to update frame buffer
      vga_waitretrace ();
 
      // fade palette
      static int
         nComp = 0,
         nInc = 1;
      nComp += nInc;
      if ( nComp == 63 || nComp == 0 )
         nInc *= -1;
      vga_setpalette ( 0, 30, 30, nComp );
 
      // show frame buffer
      // draw scanline per scanline on screen
      for ( int ncL = 0; ncL < 200; ncL ++ )
         vga_drawscansegment ( auchFrameBuffer + ncL * 320, 0, ncL, 320 );
   }
 
   vga_setmode ( TEXT );
}

